# basix.cell

Functions to get cell geometry information and manipulate cell types.

Functions

`edge_jacobians`(celltype) | Jacobians of the edges of a reference cell.
`facet_jacobians`(celltype) | Jacobians of the facets of a reference cell.
`facet_normals`(celltype) | Normals to the facets of a reference cell.
`facet_orientations`(celltype) | Orientations of the facets of a reference cell.
`facet_outward_normals`(celltype) | Normals to the facets of a reference cell.
`facet_reference_volumes`(celltype) | Reference volumes of the facets of a reference cell.
`geometry`(celltype) | Cell geometry.
`sub_entity_connectivity`(celltype) | Numbers of entities connected to each sub-entity of the cell.
`sub_entity_type`(celltype, dim, index) | Cell type of a sub-entity.
`subentity_types`(celltype) | Get the types of the subentities of a reference cell.
`topology`(celltype) | Cell topology.
`volume`(celltype) | Volume of a reference cell.

basix.cell.edge_jacobians(celltype: CellType) → ndarray[tuple[Any, ...], dtype[_ScalarT]]

  Jacobians of the edges of a reference cell.

  Parameters:

    celltype – cell type.

  Returns:

    Jacobians of the edges.

basix.cell.facet_jacobians(celltype: CellType) → ndarray[tuple[Any, ...], dtype[_ScalarT]]

  Jacobians of the facets of a reference cell.

  Parameters:

    celltype – cell type.

  Returns:

    Jacobians of the facets.

basix.cell.facet_normals(celltype: CellType) → ndarray[tuple[Any, ...], dtype[_ScalarT]]

  Normals to the facets of a reference cell.

  These normals will be oriented using the low-to-high ordering of the facet.

  Parameters:

    celltype – Cell type.

  Returns:

    Normals to the facets.

basix.cell.facet_orientations(celltype: CellType) → list[int]

  Orientations of the facets of a reference cell.

  This returns a list of bools that are `True` if the facet normal points outwards and `False` otherwise.

  Parameters:

    celltype – Cell type.

  Returns:

    Facet orientations.

basix.cell.facet_outward_normals(celltype: CellType) → ndarray[tuple[Any, ...], dtype[_ScalarT]]

  Normals to the facets of a reference cell.

  These normals will be oriented to be pointing outwards.

  Parameters:

    celltype – Cell type.

  Returns:

    Normals to the facets.

basix.cell.facet_reference_volumes(celltype: CellType) → ndarray[tuple[Any, ...], dtype[_ScalarT]]

  Reference volumes of the facets of a reference cell.

  Parameters:

    celltype – Cell type.

  Returns:

    Reference volumes.

basix.cell.sub_entity_connectivity(celltype: CellType) → list[list[list[list[int]]]]

  Numbers of entities connected to each sub-entity of the cell.

  Parameters:

    celltype – cell type.

  Returns:

    Topology (vertex indices) for each dimension (0..tdim).

basix.cell.subentity_types(celltype: CellType) → list[list[CellType]]

  Get the types of the subentities of a reference cell.

  Parameters:

    celltype – Cell type.

  Returns:

    Cell types for each sub-entity of the cell. Indices are (tdim, entity).

basix.cell.volume(celltype: CellType) → float

  Volume of a reference cell.

  Parameters:

    celltype – Cell type.

  Returns:

    Volume of the reference cell.